//          File: vertex.cpp
//        Author: Fred SisendaFeb 29, 2012

#include <iostream>
#include <vector>

using namespace std;

class Vertex{
	
	int id;
	vector<Vertex*> adjV;
	vector<int> adjW;
	
public:
	
	int data;	// might be useful
	
	// Constructor: creates a vertex with id
	Vertex(int initId){
		id = initId;
		data = 0;
	}


	// returns the id of this vertex
	int getId(){
		return id;
	}


	// returns the number of edges adjacent to this vertex
	int getNumEdges(){
		return adjV.size();
	}


	// returns the destination vertex of edge n of this vertex
	Vertex* getEdgeDest(int n){
		return adjV[n];
	}


	// returns the weight of edge n of this vertex
	int getEdgeWeight(int n){
		return adjW[n];
	}


	// prints all the edges/vertices adjacent to this vertex
	void printEdges(){
		if (adjV.size()==0)
			cout << "vertex " << id << " has no edges" << endl << endl;
		else{
			vector<Vertex>::const_iterator vIter;
			cout << "vertex " << id << " has edges to: " << endl;
			for(unsigned int ii=0; ii<adjV.size(); ii++){
				int targetId = adjV[ii]->getId();
				int weight = adjW[ii];
				cout << "\t" << targetId << " of weight " << weight << endl;
			}
			cout << endl;
		}
	}


	// adds an edge of weight w from this vertex to dest vertex
	void addEdgeTo(Vertex* dest, int w){
		adjV.push_back(dest);
		adjW.push_back(w);
	}
};
